/*
Copyright (c) 2015 Red Hat, Inc.
Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

  http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

package org.ovirt.engine.api.resource;

import javax.ws.rs.Consumes;
import javax.ws.rs.GET;
import javax.ws.rs.POST;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Response;
import org.ovirt.engine.api.model.ActionableResource;
import org.ovirt.engine.api.model.Mytest;

@Produces({ ApiMediaType.APPLICATION_XML, ApiMediaType.APPLICATION_JSON })
public interface VmMytestResource  {
    @GET
    default public Mytest doGet() {
        Mytest tests = get();
        follow(tests);
        return tests;
    }
    
    default public Mytest get() {
        throw new UnsupportedOperationException();
    }
    
    @POST
    @Consumes({ ApiMediaType.APPLICATION_XML, ApiMediaType.APPLICATION_JSON })
    default public Response doAdd(Mytest test) {
        VmMytestResourceHelper.validateAdd(test);
        return add(test);
    }
    
    default public Response add(Mytest test) {
        throw new UnsupportedOperationException();
    }
    
    default public void follow (ActionableResource entity) {
    }
    
}
